# Generated by the gRPC Python protocol compiler plugin. DO NOT EDIT!
"""Client and server classes corresponding to protobuf-defined services."""
import grpc

from authzed.api.materialize.v0 import watchpermissionsets_pb2 as authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2


class WatchPermissionSetsServiceStub(object):
    """Missing associated documentation comment in .proto file."""

    def __init__(self, channel):
        """Constructor.

        Args:
            channel: A grpc.Channel.
        """
        self.WatchPermissionSets = channel.unary_stream(
                '/authzed.api.materialize.v0.WatchPermissionSetsService/WatchPermissionSets',
                request_serializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.WatchPermissionSetsRequest.SerializeToString,
                response_deserializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.WatchPermissionSetsResponse.FromString,
                _registered_method=True)
        self.LookupPermissionSets = channel.unary_stream(
                '/authzed.api.materialize.v0.WatchPermissionSetsService/LookupPermissionSets',
                request_serializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.LookupPermissionSetsRequest.SerializeToString,
                response_deserializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.LookupPermissionSetsResponse.FromString,
                _registered_method=True)


class WatchPermissionSetsServiceServicer(object):
    """Missing associated documentation comment in .proto file."""

    def WatchPermissionSets(self, request, context):
        """WatchPermissionSets returns a stream of changes to the sets which can be used to compute the watched permissions.

        WatchPermissionSets lets consumers achieve the same thing as WatchPermissions, but trades off a simpler usage model with
        significantly lower computational requirements. Unlike WatchPermissions, this method returns changes to the sets of permissions,
        rather than the individual permissions. Permission sets are a normalized form of the computed permissions, which
        means that the consumer must perform an extra computation over this representation to obtain the final computed
        permissions, typically by intersecting the provided sets.

        For example, this would look like a JOIN between the
        materialize permission sets table in a target relation database, the table with the resources to authorize access
        to, and the table with the subject (e.g. a user).

        In exchange, the number of changes issued by WatchPermissionSets will be several orders of magnitude less than those
        emitted by WatchPermissions, which has several implications:
        - significantly less resources to compute the sets
        - significantly less messages to stream over the network
        - significantly less events to ingest on the consumer side
        - less ingestion lag from the origin SpiceDB mutation

        The type of scenarios WatchPermissionSets is particularly well suited is when a single change
        in the origin SpiceDB can yield millions of changes. For example, in the GitHub authorization model, assigning a role
        to a top-level team of an organization with hundreds of thousands of employees can lead to an explosion of
        permission change events that would require a lot of computational resources to process, both on Materialize and
        the consumer side.

        WatchPermissionSets is thus recommended for any larger scale use case where the fan-out in permission changes that
        emerges from a specific schema and data shape is too large to handle effectively.

        The API does not offer a sharding mechanism and thus there should only be one consumer per target system.
        Implementing an active-active HA consumer setup over the same target system will require coordinating which
        revisions have been consumed in order to prevent transitioning to an inconsistent state.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')

    def LookupPermissionSets(self, request, context):
        """LookupPermissionSets returns the current state of the permission sets which can be used to derive the computed permissions.
        It's typically used to backfill the state of the permission sets in the consumer side.

        It's a cursored API and the consumer is responsible to keep track of the cursor and use it on each subsequent call.
        Each stream will return <N> permission sets defined by the specified request limit. The server will keep streaming until
        the sets per stream is hit, or the current state of the sets is reached,
        whatever happens first, and then close the stream. The server will indicate there are no more changes to stream
        through the `completed_members` in the cursor.

        There may be many elements to stream, and so the consumer should be prepared to resume the stream from the last
        cursor received. Once completed, the consumer may start streaming permission set changes using WatchPermissionSets
        and the revision token from the last LookupPermissionSets response.
        """
        context.set_code(grpc.StatusCode.UNIMPLEMENTED)
        context.set_details('Method not implemented!')
        raise NotImplementedError('Method not implemented!')


def add_WatchPermissionSetsServiceServicer_to_server(servicer, server):
    rpc_method_handlers = {
            'WatchPermissionSets': grpc.unary_stream_rpc_method_handler(
                    servicer.WatchPermissionSets,
                    request_deserializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.WatchPermissionSetsRequest.FromString,
                    response_serializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.WatchPermissionSetsResponse.SerializeToString,
            ),
            'LookupPermissionSets': grpc.unary_stream_rpc_method_handler(
                    servicer.LookupPermissionSets,
                    request_deserializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.LookupPermissionSetsRequest.FromString,
                    response_serializer=authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.LookupPermissionSetsResponse.SerializeToString,
            ),
    }
    generic_handler = grpc.method_handlers_generic_handler(
            'authzed.api.materialize.v0.WatchPermissionSetsService', rpc_method_handlers)
    server.add_generic_rpc_handlers((generic_handler,))
    server.add_registered_method_handlers('authzed.api.materialize.v0.WatchPermissionSetsService', rpc_method_handlers)


 # This class is part of an EXPERIMENTAL API.
class WatchPermissionSetsService(object):
    """Missing associated documentation comment in .proto file."""

    @staticmethod
    def WatchPermissionSets(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/authzed.api.materialize.v0.WatchPermissionSetsService/WatchPermissionSets',
            authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.WatchPermissionSetsRequest.SerializeToString,
            authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.WatchPermissionSetsResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)

    @staticmethod
    def LookupPermissionSets(request,
            target,
            options=(),
            channel_credentials=None,
            call_credentials=None,
            insecure=False,
            compression=None,
            wait_for_ready=None,
            timeout=None,
            metadata=None):
        return grpc.experimental.unary_stream(
            request,
            target,
            '/authzed.api.materialize.v0.WatchPermissionSetsService/LookupPermissionSets',
            authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.LookupPermissionSetsRequest.SerializeToString,
            authzed_dot_api_dot_materialize_dot_v0_dot_watchpermissionsets__pb2.LookupPermissionSetsResponse.FromString,
            options,
            channel_credentials,
            insecure,
            call_credentials,
            compression,
            wait_for_ready,
            timeout,
            metadata,
            _registered_method=True)
